# mypy-boto3-lightsail

[![PyPI - mypy-boto3-lightsail](https://img.shields.io/pypi/v/mypy-boto3-lightsail.svg?color=blue)](https://pypi.org/project/mypy-boto3-lightsail)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-lightsail.svg?color=blue)](https://pypi.org/project/mypy-boto3-lightsail)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-lightsail](#mypy-boto3-lightsail)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)


Type annotations for
[boto3.Lightsail 1.13.24](https://boto3.amazonaws.com/v1/documentation/api/1.13.24/reference/services/lightsail.html#Lightsail) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-lightsail](#mypy-boto3-lightsail)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `Lightsail` service.

```bash
python -m pip install boto3-stubs[lightsail]

# update installed packages index for automated type discovery
python -m mypy_boto3
```

Use `boto3` with `mypy_boto3_lightsail` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_lightsail import LightsailClient

# Now mypy can check if your code is valid.
client: LightsailClient = boto3.client("lightsail")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: LightsailClient = session.client("lightsail")



# Annotated paginators are included as well

import mypy_boto3_lightsail.paginator as lightsail_paginators

get_active_names_paginator: lightsail_paginators.GetActiveNamesPaginator = client.get_paginator("get_active_names")
get_blueprints_paginator: lightsail_paginators.GetBlueprintsPaginator = client.get_paginator("get_blueprints")
get_bundles_paginator: lightsail_paginators.GetBundlesPaginator = client.get_paginator("get_bundles")
get_cloud_formation_stack_records_paginator: lightsail_paginators.GetCloudFormationStackRecordsPaginator = client.get_paginator("get_cloud_formation_stack_records")
get_disk_snapshots_paginator: lightsail_paginators.GetDiskSnapshotsPaginator = client.get_paginator("get_disk_snapshots")
get_disks_paginator: lightsail_paginators.GetDisksPaginator = client.get_paginator("get_disks")
get_domains_paginator: lightsail_paginators.GetDomainsPaginator = client.get_paginator("get_domains")
get_export_snapshot_records_paginator: lightsail_paginators.GetExportSnapshotRecordsPaginator = client.get_paginator("get_export_snapshot_records")
get_instance_snapshots_paginator: lightsail_paginators.GetInstanceSnapshotsPaginator = client.get_paginator("get_instance_snapshots")
get_instances_paginator: lightsail_paginators.GetInstancesPaginator = client.get_paginator("get_instances")
get_key_pairs_paginator: lightsail_paginators.GetKeyPairsPaginator = client.get_paginator("get_key_pairs")
get_load_balancers_paginator: lightsail_paginators.GetLoadBalancersPaginator = client.get_paginator("get_load_balancers")
get_operations_paginator: lightsail_paginators.GetOperationsPaginator = client.get_paginator("get_operations")
get_relational_database_blueprints_paginator: lightsail_paginators.GetRelationalDatabaseBlueprintsPaginator = client.get_paginator("get_relational_database_blueprints")
get_relational_database_bundles_paginator: lightsail_paginators.GetRelationalDatabaseBundlesPaginator = client.get_paginator("get_relational_database_bundles")
get_relational_database_events_paginator: lightsail_paginators.GetRelationalDatabaseEventsPaginator = client.get_paginator("get_relational_database_events")
get_relational_database_parameters_paginator: lightsail_paginators.GetRelationalDatabaseParametersPaginator = client.get_paginator("get_relational_database_parameters")
get_relational_database_snapshots_paginator: lightsail_paginators.GetRelationalDatabaseSnapshotsPaginator = client.get_paginator("get_relational_database_snapshots")
get_relational_databases_paginator: lightsail_paginators.GetRelationalDatabasesPaginator = client.get_paginator("get_relational_databases")
get_static_ips_paginator: lightsail_paginators.GetStaticIpsPaginator = client.get_paginator("get_static_ips")
```

## Automated type discovery

`mypy_boto3` package can generate index for `mypy_boto3_lightsail` and other installed services.

```bash
# Run this command when you add or remove service packages
python -m mypy_boto3
```

Generated index provides overloads for `boto3.client` and `boto3.service`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully
- `VSCode` does not currently support function overloads

Also, generated index allows you to import types from `mypy_boto3`:

```python
# you can replace imports
import mypy_boto3_lightsail as lightsail
from mypy_boto3_lightsail import LightsailClient

# with these
from mypy_boto3 import lightsail
from mypy_boto3.lightsail import LightsailClient
```